unit UZ801;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, SortGrid, ComCtrls, Mjwcrt, Buttons, Menus,
  Md5DeftEdit;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    btnResetZ80: TButton;
    btnRunZ80: TButton;
    Panel3: TPanel;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    CRT: TMJWcrt;
    btnStep: TButton;
    SpeedButton1: TSpeedButton;
    TabSheet2: TTabSheet;
    btnSubroutineCall: TButton;
    TabSheet3: TTabSheet;
    btnStopZ80CPU: TButton;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    Memo2: TMemo;
    btnTrackDown: TButton;
    btnSectorDown: TButton;
    btnDiskRead: TButton;
    btnSectorUp: TButton;
    btnTrackUp: TButton;
    RadioGroup2: TRadioGroup;
    btnOpenDiskfile: TButton;
    Panel4: TPanel;
    Status: TLabel;
    PopupMenu1: TPopupMenu;
    CopyCRTtoclip1: TMenuItem;
    TabSheet6: TTabSheet;
    Memo3: TMemo;
    ShowDebugOut: TCheckBox;
    TraceMemo: TMemo;
    Label6: TLabel;
    Memo1: TMemo;
    btnDisplayMemory: TButton;
    btnMemoryDown: TButton;
    btnMemoryDownDown: TButton;
    btnMemoryUp: TButton;
    btnMemoryUpUp: TButton;
    RadioGroup1: TRadioGroup;
    btnClearMemory: TButton;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    btnPatchit: TButton;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    btnSetPC: TButton;
    ListBox1: TListBox;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    btnShowState: TButton;
    btnSaveLabels: TButton;
    StringGrid1: TSortGrid;
    Edit8: TEdit;
    btnSetPcodeBreakPoint: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Loadcode1: TMenuItem;
    Quit1: TMenuItem;
    Z801: TMenuItem;
    StartZ80emulatoratPC1: TMenuItem;
    sTopZ80emulator1: TMenuItem;
    ResetZ801: TMenuItem;
    VirtualDiscdrives1: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N91: TMenuItem;
    N101: TMenuItem;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    GroupBox3: TGroupBox;
    Label2: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    btnDrive4: TButton;
    btnDrive5: TButton;
    btnDrive9: TButton;
    btnDrive10: TButton;
    GroupBox4: TGroupBox;
    LoadCodeAddress: TRadioGroup;
    Edit9: TEdit;
    btnLoadCode: TButton;
    GroupBox5: TGroupBox;
    RadioGroup3: TRadioGroup;
    DeftEdit1: TDeftEdit;
    Label14: TLabel;
    GroupBox6: TGroupBox;
    RegisterCRT: TMJWcrt;
    GroupBox7: TGroupBox;
    AssemblerCRT: TMJWcrt;
    GroupBox8: TGroupBox;
    StackCRT: TMJWcrt;
    btnShowState2: TButton;
    Label8: TLabel;
    ShowPC: TCheckBox;
    Label13: TLabel;
    Label15: TLabel;
    Help1: TMenuItem;
    About1: TMenuItem;
    procedure btnResetZ80Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnRunZ80Click(Sender: TObject);
    procedure btnLoadCodeClick(Sender: TObject);
    procedure btnSetPCClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure btnDrive4Click(Sender: TObject);
    procedure btnShowStateClick(Sender: TObject);
    procedure btnStepClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure CRTKeyPress(Sender: TObject; var Key: Char);
    procedure btnSaveLabelsClick(Sender: TObject);
    procedure btnDisplayMemoryClick(Sender: TObject);
    procedure btnMemoryDownClick(Sender: TObject);
    procedure btnMemoryDownDownClick(Sender: TObject);
    procedure btnMemoryUpClick(Sender: TObject);
    procedure btnMemoryUpUpClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure btnSubroutineCallClick(Sender: TObject);
    procedure btnPatchitClick(Sender: TObject);
    procedure btnStopZ80CPUClick(Sender: TObject);
    procedure CRTClick(Sender: TObject);
    procedure btnDiskReadClick(Sender: TObject);
    procedure btnOpenDiskfileClick(Sender: TObject);
    procedure btnTrackDownClick(Sender: TObject);
    procedure btnSectorDownClick(Sender: TObject);
    procedure btnSectorUpClick(Sender: TObject);
    procedure btnTrackUpClick(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure btnClearMemoryClick(Sender: TObject);
    procedure btnDrive5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnSetPcodeBreakPointClick(Sender: TObject);
    procedure RadioGroup3Click(Sender: TObject);
    procedure btnDrive9Click(Sender: TObject);
    procedure btnDrive10Click(Sender: TObject);
    procedure CRTKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure CopyCRTtoclip1Click(Sender: TObject);
    procedure CRTMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LoadCodeAddressClick(Sender: TObject);
    procedure DeftEdit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Loadcode1Click(Sender: TObject);
    procedure N41Click(Sender: TObject);
    procedure N51Click(Sender: TObject);
    procedure N91Click(Sender: TObject);
    procedure N101Click(Sender: TObject);
    procedure StartZ80emulatoratPC1Click(Sender: TObject);
    procedure sTopZ80emulator1Click(Sender: TObject);
    procedure ResetZ801Click(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure btnShowState2Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  Memory : Array[0..$FFFF] of byte;

implementation

uses z80,Z80Int, UEMHelp, EMAbout;

{$R *.DFM}
Type
  TTerminal = (TTNone,TTSoroc,TTADM3A,TTVT52,TTVT100,TTTerak);


var ll:llam_Z80;
    r:preg_Z80;

  DisplayOffset : WORD;    //offset to display memory contents.
  DisplayAsHex  : boolean;    // show as hex or Ascii
  NumLabels : integer;        //number of symbolic labels for a code file
  CPMDISK   : Integer;        //magic num = $22 if not initialized
  Drive4Name : String;        //= 'C:\BOOP.RAW';
  Drive5Name : String;        //= 'C:\15FIX1.RAW'
  Drive9Name : String;        //= 'C:\BOOP.RAW';
  Drive10Name : String;        //= 'C:\15FIX1.RAW'

  U_IP, next_IP, Old_IP: Word;//used by disassembler
  AtIntercept   : Boolean;    //True if r.PC.W is at an intercept address:Word;         //used by disassembler
  AtWarmBoot    : Boolean;    //True if Jump to 0 JMP 0  CP/M warmboot
  dum : integer;
  SingleStep : Boolean;
  Step:integer;               //if single stepping, number of steps to execute.
                              //Normally = 1 for single step
  PCodeBPT: Integer;          //Pcode breakpoint;
Var
  DiskSector, DiskTrack:integer;
  DiskDisplayAsHex:Boolean;
Var
  Terminal : TTerminal;



Function MyStrToInt(s:string):Integer;
var v:Longint; Code: Integer;
Begin
  while (s<>'') and (s[1]=' ') do delete(s,1,1);
  if s='' then begin Result:=0; exit; end;  //catch nil string exception
  Val(s,v,code);   //catch error before call to StrToInt()
  if code>0 then result:=0
  else Result := StrToInt(s);
end;



Procedure CheckForLabel(Var s:string);  //Search for address that matches a symbolic label
var i,x:integer; addrs,lab:string;
Begin
  for i:= 1 to NumLabels do begin
    addrs:=Form1.StringGrid1.Cells[0,i]; lab:=Form1.StringGrid1.Cells[1,i];
    if (addrs='') or (lab='') then continue; //exit of either a null string
//    addrs:='$'+addrs;
    x:=pos(addrs,s);
    While length(lab) < 5 do lab:=lab+' ';
    while x>0 do begin
      delete(s,x,length(addrs));
      insert(lab,s,x);
      if (x>1) and (s[x-1]='$') then delete(s,x-1,1);  //get rid of '$' in front of label
      x:=pos(addrs,s);
      end;
    end;
end;


Var BreakPoints : Array[1..10] of word;
    Numbreakpoints : 0..10;

Function CheckForBreakPoint(a:word):integer;
var i:integer;
Begin
  result := 0;
  for i:= 1 to 10 do
    if a=BreakPoints[i] then begin
      Result:=i; break;
      end;
end;

Procedure AddBreakpoint(a:Word);
Begin
  inc(Numbreakpoints);
  Breakpoints[Numbreakpoints] := a;
end;

Procedure RemoveBreakpoint(i:word);   //Remove breakpoint at index i
Begin
  Breakpoints[i]:=0;
  dec(Numbreakpoints);
end;


Function HexBYTE(value:byte):String;  {Returns a string corresponding to a byte}
Var hexdigit : array [0..15] of char;
Begin
  hexdigit:='0123456789ABCDEF';
  HexByte:='  ';  //2 spaces
  HexByte[1] := hexdigit[value  div 16];
  HexByte[2] := hexdigit[value  mod 16];
End;

Function Hexword(value:Word):String; {Returns a string corresponding to a word}
Var Low,high : byte;
    hexdigit : array [0..15] of char;
Begin
  IF VALUE >=0 THEN
    BEGIN
  hexdigit:='0123456789ABCDEF';
  low := value mod 256;
  high := value div 256;
  HexWord:='    ';  //4 spaces
  hexWord[1] := hexdigit[high div 16];
  hexWord[2] := hexdigit[high mod 16];
  hexWord[3] := hexdigit[low  div 16];
  hexWord[4] := hexdigit[low  mod 16];
    END;
End;


Function dec_to_Hex(w:word;l:byte):string;
Begin
  Case l of
    2 : dec_to_hex := HexByte( w and $FF);
    4 : dec_to_hex := HexWord(w);
    end;
end;


FUNCTION Hex_to_Dec(Hex:STRING):LongInt;
  Function MyPower(base,p:integer):longint;
  Begin
    case p of
      0 : Result := 1;
      1 : Result := base;
      2 : Result := base * base;
      3 : Result := Base*base*base;
      4 : Result := base*base*base*base;
      5 : Result := base*base*base*base*base;
      6 : Result := base*base*base*base*base*base;
      7 : Result := base*base*base*base*base*base*base;
      end;
  end;
VAR
   T1,T2,Dec   :       integer;
      Error    :       Boolean;
BEGIN
  Error:=False;
  T1:=0;T2:=0;DEC:=0;
  FOR T1:=1 TO LENGTH(Hex) DO
  BEGIN
   T2:=Length(Hex)-T1;
   CASE Hex[T1] OF
   '0'  : DEC:=DEC+0;
   '1'  : DEC:=DEC+  myPower(16,T2);
   '2'  : DEC:=DEC+2*myPower(16,T2);
   '3'  : DEC:=DEC+3*myPower(16,T2);
   '4'  : DEC:=DEC+4*myPower(16,T2);
   '5'  : DEC:=DEC+5*myPower(16,T2);
   '6'  : DEC:=DEC+6*myPower(16,T2);
   '7'  : DEC:=DEC+7*myPower(16,T2);
   '8'  : DEC:=DEC+8*myPower(16,T2);
   '9'  : DEC:=DEC+9*myPower(16,T2);
   'A','a' : DEC:=DEC+10*myPower(16,T2);
   'B','b' : DEC:=DEC+11*myPower(16,T2);
   'C','c' : DEC:=DEC+12*myPower(16,T2);
   'D','d' : DEC:=DEC+13*myPower(16,T2);
   'E','e' : DEC:=DEC+14*myPower(16,T2);
   'F','f' : DEC:=DEC+15*myPower(16,T2);
   ELSE Error:=True;
   END;
  END;
  Hex_to_Dec:=Dec;
  IF Error THEN Hex_to_Dec:=0;
END; { Hex2Dec }

function zoek(ch:char;pst:string):integer;
var tl:integer;
begin
  tl:=1;
  while ((tl<=length(pst)) and (pst[tl]<>ch)) do inc(tl);
  if tl>length(pst) then zoek:=0 else zoek:=tl;
end;

function ml(pst:string; m:byte; pbo:boolean):string;
begin
  if m>76 then m:=76;
  if pbo then while length(pst)<m do pst:=pst+' '
    else while length(pst)<m do pst:=' '+pst;
  ml:=pst;
end;




function zin(i:integer):string;
begin
  case i of
   0 : zin:='HEX-display -Professor';
   1 : zin:='Registers';
   3 : zin:='A  =  ';    //appears in line 1 in register screen
   4 : zin:='BC =';
   5 : zin:='DE =';
   6 : zin:='HL =';
   7 : zin:='IX =';
   8 : zin:='IY =';
   9 : zin:='SP =';
   10: zin:='PC =';
   11: zin:='IR =';
   12: zin:='AF~=';
   13: zin:='BC~=';
   14: zin:='DE~=';
   15: zin:='HL~=';
   16: zin:='';
 //17: zin:=' UHSPZC' ;    Original code
   17: zin:='SZ-H-PNC';
 //18: zin:=' 000000';
   18: zin:='00 0 000';
   30: zin:=' -   -   -   -   -   -';
   31: zin:='            ';
   32: zin:=' -   -   -   -   -   -';
   33: zin:='            ';
   34: zin:=' -  -  -  -  -  - ';
    else zin:='???';
  end;
end;

procedure show_stack;
var i:integer;
begin with Form1.StackCRT do
  for i:=0 to 18 do
   begin
    gotoxy(3,2+i);
//  write(dec_to_hex(SP-8+i,4)+': '+dec_to_hex(buffer[SP-8+i],2));
    if i=16 then begin gotoxy(1,2+i);write('>>');end;
    write(dec_to_hex(r.SP.W+16-i,4)+': '+dec_to_hex(Memory[r.SP.W+16-i],2));
    if i=16 then write('<<');
   end;
end;

procedure show_registers;
begin
  With Form1.RegisterCRT do begin
    gotoxy(8,1); write(dec_to_hex(r.A,2));
    gotoxy(6,2); write(dec_to_hex(r.BC.w,4));
    gotoxy(6,3); write(dec_to_hex(r.DE.w,4));
    gotoxy(6,4); write(dec_to_hex(r.HL.w,4));
    gotoxy(6,5); write(dec_to_hex(r.IX.w,4));
    gotoxy(6,6); write(dec_to_hex(r.IY.W,4));
    gotoxy(6,7); write(dec_to_hex(r.SP.W,4));
    gotoxy(6,8); write(dec_to_hex(r.PC.W,4));  //IP in earlier version
    gotoxy(6,9); write(dec_to_hex((r.I shl 8)+r.R,4));
    gotoxy(16,1); write(dec_to_hex((r.A2 ),2));  //was _A
    gotoxy(16,2); write(dec_to_hex(r.BC2.W,4));
    gotoxy(16,3); write(dec_to_hex(r.DE2.W,4));
    gotoxy(16,4); write(dec_to_hex(r.HL2.W,4));
    gotoxy(3,16);
    (*   original code
    if UF then write('1') else write('0');
    if HF then write('1') else write('0');
    if SF then write('1') else write('0');
    if PF then write('1') else write('0');
    if ZF then write('1') else write('0');
    if CF then write('1') else write('0');
    *)
     gotoxy(12,7);
        if r.f.s then write('1') else write('0');
        if r.f.z then write('1') else write('0');
        Write('-');//but could be..if (r.AF.l and U2_FLAG)>0then write('1') else write('0');
        if r.f.h then write('1') else write('0');
        Write('-');//but could be..if (r.AF.l and U1_FLAG)>0then write('1') else write('0');
        if r.f.p_v then write('1') else write('0');
        //P_Flag is also V_Flag !!!
        if r.f.n then write('1') else write('0');
        if r.f.c then write('1') else write('0');

    gotoxy(12,8);
    Write('Zero =');If r.f.z then write('1') else write('0');
    gotoxy(12,9);
    Write('Carry=');If r.f.c then write('1') else write('0');

  end;
end;





procedure unassemble_code;
var
  pb : boolean;
  da,zk : byte;
  c : char;
  j : integer;
  tl,pl : longint;
  regel,pst : string;
  wo,IP2 : word;
label PL1,PL2;
begin
  IP2:=U_IP;
  regel:='$'+dec_to_hex(IP2,4)+' :   ';
  da:=memory[IP2];                         {* eerste opcode *}
  c:=opcode[da][13];
  pst:=copy(opcode[da],1,12);
  regel:=regel+dec_to_hex(da,2)+' ';
PL1:
  if ((c='1') or (c='2')) then
   begin                                       {* zoek 'n' in opcode *}
    zk:=zoek('n',pst);
    inc(IP2);
    regel:=regel+dec_to_hex(memory[IP2],2)+' ';
    pst:=copy(pst,1,zk-1)+'$'+dec_to_hex(memory[IP2],2)+
           copy(pst,zk+1,length(pst)-zk);
   end;
  if c='2' then
   begin
    inc(IP2);
    regel:=regel+dec_to_hex(memory[IP2],2);
    pst:=copy(pst,1,zk)+dec_to_hex(Memory[IP2],2)+
           copy(pst,zk+1,length(pst)-zk);
   end;
  if c='3' then
   begin
    zk:=zoek('n',pst);
    inc(IP2);
    regel:=regel+dec_to_hex(Memory[IP2],2)+' ';
    if memory[IP2]<$80 then pl:=IP2+1+Memory[IP2]
     else pl:=IP2-255+Memory[IP2];
    pst:=copy(pst,1,zk-1)+'$'+dec_to_hex(pl,4);
   end;

  if c='9' then
   begin
    inc(IP2);
    j:=da;
    da:=Memory[IP2];
    regel:=regel+dec_to_hex(da,2)+' ';
    case j of
     203 : pst:=opcodeCB[da];
     221 : pst:=opcodeDD[da];
     237 : pst:=opcodeED[da];
     253 : pst:=opcodeFD[da];
    end;
    c:=pst[13];
    pst:=copy(pst,1,12);
    case c of
     ' ','1','2' : goto PL1;
     '9' : begin
       inc(IP2,2);
       da:=Memory[IP2];
       case j of
        221 : pst:=opcodeDDCB[da];
        253 : pst:=opcodeFDCB[da];
       end;
       j:=da;
       da:=Memory[IP2-1];
       c:=pst[13];
       pst:=copy(pst,1,12);
       if c='1' then
        begin
         zk:=zoek('n',pst);
         regel:=regel+dec_to_hex(da,2)+' ';
         pst:=copy(pst,1,zk-1)+'$'+dec_to_hex(da,2)+copy(pst,zk+1,length(pst)-zk);
        end;
       regel:=regel+dec_to_hex(j,2)+' ';
      end;
     '4' : begin
       zk:=zoek('i',pst);
       inc(IP2);
       regel:=regel+dec_to_hex(Memory[IP2],2)+' ';
       pst:=copy(pst,1,zk-1)+'$'+dec_to_hex(Memory[IP2],2)+
           copy(pst,zk+1,length(pst)-zk);
       c:='1';
       goto PL1;
      end;
     end;
   end;

  inc(IP2);
  regel:=ml(ml(regel,24,true)+pst,48,true);
  CheckForLabel(regel);
  With Form1.AssemblerCRT do begin
    //if U_IP is a breakpoint then show it
    if CheckForBreakpoint(U_IP) > 0 then begin
      TextColor := Tcolor(clred);
      gotoxy(1,wherey); Write('**');
      end
    else begin
      TextColor := Tcolor(clblack);
      gotoxy(1,wherey); Write('  ');   //clear the double asterix
      end;
    Gotoxy(3,wherey);
    write(regel);
    gotoxy(3,wherey+1);
    end;
  U_IP:=IP2;
  if ((dum=1) {and not proceed}) then next_IP:=IP2;
end;

Function UnassembleLine(Var U_IP:word):String;   //Based on Unassemble_code
var
  pb : boolean;
  da,zk : byte;
  c : char;
  j : integer;
  tl,pl : longint;
  regel,pst : string;
  wo,IP2 : word;
label PL1,PL2;
begin
  IP2:=U_IP;
  regel:='$'+dec_to_hex(IP2,4)+' :   ';
  da:=Memory[IP2];                         {* eerste opcode *}
  c:=opcode[da][13];
  pst:=copy(opcode[da],1,12);
  regel:=regel+dec_to_hex(da,2)+' ';
PL1:
  if ((c='1') or (c='2')) then
   begin                                       {* zoek 'n' in opcode *}
    zk:=zoek('n',pst);
    inc(IP2);
    regel:=regel+dec_to_hex(Memory[IP2],2)+' ';
    pst:=copy(pst,1,zk-1)+'$'+dec_to_hex(Memory[IP2],2)+
           copy(pst,zk+1,length(pst)-zk);
   end;
  if c='2' then
   begin
    inc(IP2);
    regel:=regel+dec_to_hex(Memory[IP2],2);
    pst:=copy(pst,1,zk)+dec_to_hex(Memory[IP2],2)+
           copy(pst,zk+1,length(pst)-zk);
   end;
  if c='3' then
   begin
    zk:=zoek('n',pst);
    inc(IP2);
    regel:=regel+dec_to_hex(Memory[IP2],2)+' ';
    if Memory[IP2]<$80 then pl:=IP2+1+Memory[IP2]
     else pl:=IP2-255+Memory[IP2];
    pst:=copy(pst,1,zk-1)+'$'+dec_to_hex(pl,4);
   end;

  if c='9' then
   begin
    inc(IP2);
    j:=da;
    da:=Memory[IP2];
    regel:=regel+dec_to_hex(da,2)+' ';
    case j of
     203 : pst:=opcodeCB[da];
     221 : pst:=opcodeDD[da];
     237 : pst:=opcodeED[da];
     253 : pst:=opcodeFD[da];
    end;
    c:=pst[13];
    pst:=copy(pst,1,12);
    case c of
     ' ','1','2' : goto PL1;
     '9' : begin
       inc(IP2,2);
       da:=Memory[IP2];
       case j of
        221 : pst:=opcodeDDCB[da];
        253 : pst:=opcodeFDCB[da];
       end;
       j:=da;
       da:=Memory[IP2-1];
       c:=pst[13];
       pst:=copy(pst,1,12);
       if c='1' then
        begin
         zk:=zoek('n',pst);
         regel:=regel+dec_to_hex(da,2)+' ';
         pst:=copy(pst,1,zk-1)+'$'+dec_to_hex(da,2)+copy(pst,zk+1,length(pst)-zk);
        end;
       regel:=regel+dec_to_hex(j,2)+' ';
      end;
     '4' : begin
       zk:=zoek('i',pst);
       inc(IP2);
       regel:=regel+dec_to_hex(Memory[IP2],2)+' ';
       pst:=copy(pst,1,zk-1)+'$'+dec_to_hex(Memory[IP2],2)+
           copy(pst,zk+1,length(pst)-zk);
       c:='1';
       goto PL1;
      end;
     end;
   end;

  inc(IP2);
  regel:=ml(ml(regel,24,true)+pst,48,true);
  CheckForLabel(regel);
  Result := regel;
    //if U_IP is a breakpoint then show it
    if CheckForBreakpoint(U_IP) > 0 then begin
      end
    else begin
      end;
  U_IP:=IP2;
  if ((dum=1) {and not proceed}) then next_IP:=IP2;
end;


type
  TSector = packed array[0..127] of byte;
var
  CpmDiskAFile : File of Tsector;
  CpmDiskBFile : File of Tsector;
  CpmDiskCFile : File of Tsector;
  CpmDiskDFile : File of Tsector;

  //  CPMDISKa   : Byte;  //Current CPM Disk to select.  Will translate to a file
  CPMTRACK  : Word;
  CPMSECTOR : Word;
  CPMDMA    : Word;  //Address to read or write to...
  CRTKeypressed : Boolean;
  CRTKEY : Char;

//Debug support code
Procedure DumpSector(Sector:TSector);
var i:integer; s:string;
Begin
  s:='';
  for i:=0 to 127 do if Sector[i] < 32 then s:=s+'.'
    else s:=s+chr(Sector[i]);
  If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add(s);
end;

Procedure CPMWBOOT;
Begin
  ShowMessage('CP/M Warm re-boot detected, emulation will stop');
  r.enabled := false;
end;
Procedure CPMCONST; //Returns status in A; 0 if no character ready, $FF if one is.
Begin
  If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('CPM CONST');
  if CRTKeyPRessed then begin
    r.A := $FF; r.f.z := false;   //Clear Z flag
    end
  else begin
    r.A := $00; r.f.z := true;  //set Z flag
    end;
end;

Procedure CONIN;   //Wait for char, return it in A
Begin
  If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('CPM CONIN');
  Form1.CRT.SetFocus;
  Form1.CRT.Cursor:=true;
  Repeat
    //get out if user has requested stop CPU
    if r.enabled=false then exit;
    Application.ProcessMessages;

  Until CRTKeyPRessed;
  r.A := byte(CRTKEY); r.f.z := (r.A = 0); //set or Clear Z flag
  CRTKeyPressed := false;
end;

Procedure GotoXY(x,y:integer);
Begin
  Form1.CRT.GotoXY(x,y);
end;
Function WhereX:Integer;
Begin
  Result :=Form1.CRT.WhereX;
end;
Function WhereY:Integer;
Begin
  Result :=Form1.CRT.WhereY;
end;

var LastChar : Char; ScX,ScY:integer; Mode : (nothing,ESC,WaitForX,WaitForY,WaitForColon, WaitForH);
    Prefixed,DoubleESC : Boolean;

Procedure CONOUTADM3A;    //ADM-3A gotoxy   27 61 y+32 X+32 For NEWPAS.RAW
Label 99; var c: Char;
Begin
  c:= char(r.BC.l);
  If Mode = WaitForY then begin
                          ScY:=ord(c)-32; Mode:=Nothing;Form1.CRT.GotoXY(ScX+1,ScY+1); exit;
                          end;
  If Mode = WaitForX then begin ScX:=ord(c)-32; Mode:=WaitForY; exit; end;
  If Mode =ESC then begin
                      if c=#61 then begin Mode:=WaitForX; exit; end;
                      if c='T' then begin Form1.CRT.ClrEol; Mode:=nothing; exit end;
                      if c='Y' then begin Form1.CRT.ClrEoP; Mode:=nothing; exit end;
                      end;
  if c=#27 then begin Mode := ESC ; goto 99; end;
  Mode := Nothing;
  if c=#30 then begin Form1.CRT.gotoxy(1,1); goto 99;  end;
  if c=#13 then begin Form1.CRT.GotoXY(1,Form1.CRT.WhereY); goto 99;  end;
  if c=#26 then begin Form1.CRT.ClrScr; goto 99;  end;
(*

  if c=#11 then begin Form1.CRT.ClrEoP; goto 99;  end;

  if c=#25 then begin Form1.CRT.GotoXY(1,1); goto 99; end;
  if c=#29 then begin Form1.CRT.ClrEol ; goto 99; end;
*)
  If Form1.ShowDebugOut.Checked then begin
    Form1.Memo3.Lines.Add('CPM CONOUT '+char(r.bc.l));
    if ord(c) < 32 then Form1.Memo3.Lines.Add('ctrl-char = '+IntToStr(ord(c)));
    end;
//  if ord(c) < 32 then showmessage('CONOUT '+IntToStr(ord(c)));
  Form1.CRT.WriteChar(c);   //CONOUT WriteChar in C
99:
  LastChar :=c;
end;


Procedure CONOUTSoroc;    //SOROC IQ-120    GOTOXY CHR 30 X+32 Y+32   BOOP.RAW
Label 99;
var c: Char;
Begin
  c:= char(r.BC.l);
  If Mode = WaitForY then begin
                          ScY:=Ord(c)-32+1; Mode:=nothing; Form1.CRT.GotoXY(ScX,ScY);
                          exit;
                          end;
  If Mode = WaitForX then begin
                          ScX:=ord(c)-32+1; Mode:=WaitForY; exit;
                          end;

  if c=#11 then begin Form1.CRT.ClrEoP; goto 99;  end;
  if c=#13 then begin Form1.CRT.GotoXY(1,Form1.CRT.WhereY); goto 99;  end;
  if c=#25 then begin Form1.CRT.GotoXY(1,1); goto 99; end;
  if c=#29 then begin Form1.CRT.ClrEol ; goto 99; end;
  if c=#30 then begin Mode := WaitForX ;exit; end;
  If Form1.ShowDebugOut.Checked then begin
    Form1.Memo3.Lines.Add('CPM CONOUT '+char(r.bc.l));
    if ord(c) < 32 then Form1.Memo3.Lines.Add('ctrl-char = '+IntToStr(ord(c)));
    end;
  Form1.CRT.WriteChar(c);   //CONOUT WriteChar in C
99:
  LastChar :=c;
end;

(*  VT52 Mode gotoxy = ESC Y Y+32 X+32
ESC A   Cursor up.
ESC B   Cursor down.
ESC C   Cursor right.
ESC D   Cursor left.
ESC F   Enter graphics mode.
ESC G   Exit graphics mode.
ESC H   Move the cursor to the home position.
ESC I   Reverse line feed.
ESC J   Erase from the cursor to the end of the screen.
ESC K   Erase from the cursor to the end of the line.
ESC Z   Identify ? ESC / Z (I am a VT52.)
ESC =   Enter alternate keypad mode.
ESC >   Exit alternate keypad mode.
ESC <   Exit VT52 mode (Enter VT100 mode).
*)

Procedure CONOUTVT52;  //gotoxy = ESC Y Y+32 X+32
Label 99;
var c: Char;
Begin
  c:= char(r.BC.l);
  If Mode=WaitForX then begin ScX := ord(c)-32; GotoXy(ScX+1,ScY+1);Mode :=nothing; exit; end;
  If Mode=WaitForY then begin ScY := ord(c)-32; Mode :=WaitForX; exit; end;
  if Prefixed and(c='Y')then begin Mode := WaitForY; goto 99;    end;
  if c=#27 then begin Prefixed := true; Mode := Nothing; exit; end;
  if Prefixed then case c of
    'A' : begin gotoxy(WhereX,WhereY-1); goto 99; end; //up
    'B' : begin gotoxy(WhereX,WhereY+1); goto 99; end; //down
    'C' : begin gotoxy(WhereX+1,WhereY); goto 99; end; //right
    'D' : begin gotoxy(WhereX-1,WhereY); goto 99; end; //left
    'H' : begin gotoxy(1,1); goto 99; end; //Home
    'J' : begin Form1.CRT.ClrEOP; goto 99; end; //ERAEOS
    'K' : begin Form1.CRT.ClrEOL; goto 99; end; //ERAEOL
    end;  //case c

  If Form1.ShowDebugOut.Checked then begin
    Form1.Memo3.Lines.Add('CPM CONOUT '+c);
    if ord(c) < 32 then Form1.Memo3.Lines.Add('ctrl-char = '+IntToStr(ord(c)));
    end;
//  if ord(c) < 32 then showmessage('CONOUT '+IntToStr(ord(c)));
  if c=#13 then begin
    gotoxy(1,WhereY);  //True CR has no LF
    goto 99;
    end;
  Form1.CRT.WriteChar(c);   //CONOUT WriteChar in C
99: Prefixed := false;
end;
var sx,sy:string;
Procedure CONOUTVT100;    //For PASCALZ   UCSDI5-1.DSK VT-100
Label 99;  var c: Char;   //GOTOXY CHR 27 Y+48  ; X+48 H
Begin
  c:= char(r.BC.l);
  If (Mode=WaitForX)and(c='H') then begin  Mode :=Nothing;
    If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('X='+sx);
    ScX := MyStrToInt(sx); ScY := MyStrToInt(sy); Gotoxy(Scx,Scy);
     exit; end;
  if mode=WaitforX then begin sx:=sx+c; exit; end;
  if  (Mode=WaitforY) and (c=';') then Begin Mode := WaitforX;
    If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('Y='+sy); exit; end;
  If Mode=WaitForY then begin sy:=sy+c;exit; end;
  if Prefixed and(c=#27)then begin sx:='';sy:='';Mode:=WaitForY;
    If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('mode=WaitforY');goto 99;end;
  if c=#27 then begin Prefixed := true; Mode := Nothing; exit; end;
  if Prefixed then case c of
    'A' : begin gotoxy(WhereX,WhereY-1); goto 99; end; //up
    'C' : begin gotoxy(WhereX+1,WhereY); goto 99; end; //right
    'H' : begin gotoxy(1,1); goto 99; end; //right
    'J' : begin Form1.CRT.ClrEOP; goto 99; end; //ERAEOS
    'K' : begin Form1.CRT.ClrEOL; goto 99; end; //ERAEOL
    end;  //case c


  if c=#11 then begin Form1.CRT.ClrEoP; goto 99;  end;
  if c=#13 then begin Form1.CRT.GotoXY(1,Form1.CRT.WhereY); goto 99;  end;
  if c=#25 then begin Form1.CRT.GotoXY(1,1); goto 99; end;
  if c=#29 then begin Form1.CRT.ClrEol ; goto 99; end;
  if c=#30 then begin Mode := WaitForX ;{ goto 99;} end;

  If Form1.ShowDebugOut.Checked then begin
    Form1.Memo3.Lines.Add('CPM CONOUT '+c);
    if ord(c) < 32 then Form1.Memo3.Lines.Add('ctrl-char = '+IntToStr(ord(c)));
    end;
  Form1.CRT.WriteChar(c);   //CONOUT WriteChar in C
99:
  Prefixed := false;
end;

Procedure CONOUTTerak;
Begin
(*
  Terak 8510a graphics screen id 320 x 240 dots.
  Screen = array[0..9728] of char.  Foto file ia 19 blocks on disk
  CHEDIT edits a character in 10x8 matrix.  See I.4 manual
  {  Cntrl character constants initialized  }
    null := CHR(0);
    soh := CHR(1);
    stx := CHR(2);
    etx := CHR(3);
    eot := CHR(4);
    enq := CHR(5);
    ack := CHR(6);
    bell := CHR(7);
    bs := CHR(8);
    ht := CHR(9);
    linef := CHR(10);
    vt := CHR(11);
    formf := CHR(12);
    rtn := CHR(13);
    so := CHR(14);
    si := CHR(15);
    dle := CHR(16);
    dc1 := CHR(17);
    dc2 := CHR(18);
    dc3 := CHR(19);
    dc4 := CHR(20);
    nak := CHR(21);
    syn := CHR(22);
    etb := CHR(23);
    can := CHR(24);
    eom := CHR(25);
    sub := CHR(26);
    esc := CHR(27);
    fs := CHR(28);
    gs := CHR(29);
    rs := CHR(30);
    us := CHR(31);
    del := CHR(127);
{  Initialize Terak control characters  }
   upcursor := us;
   eraseln := null;
   clrscr := formf;
   erstoeol := gs;
   erstoeos := vt;
   home := eom;
   rcursor := fs;
   lcursor := bs;
   docursor := linef;
   startrans := dc1;
   stoptrans := dc3;
*)
end;

Procedure LIST;
Begin
  Form1.Memo3.Lines.Add('CPM LIST');
  //dummy
end;
Procedure PUNCH;
Begin
  Form1.Memo3.Lines.Add('CPM PUNCH');
  //dummy
end;
Procedure READER;
Begin
  Form1.Memo3.Lines.Add('CPM READER');
  //dummy
end;


Procedure CPMHOME;
Begin
  Form1.Memo3.Lines.Add('CPM HOME');
  CPMTRACK := 0; //  r.AF.h := 0;  //pass back no error code
end;

(*  Select the disc drive in register C (0=A:, 1=B: ...). Called with E=0 or 0FFFFh.
    If bit 0 of E is 0, then the disc is logged in as if new; if the format has
    to be determined from the boot sector, for example, this will be done.
    If bit 0 if E is 1, then the disc has been logged in before. The disc is not
    accessed; the DPH address (or zero) is returned immediately.
    SELDSK returns the address of a Disc Parameter Header in HL. The exact
    format of a DPH varies between CP/M versions; note that under CP/M 3,
    the DPH is in memory bank 0 and probably not visible to programs.
    If the disc could not be selected it returns HL=0.
*)
Function CPMSELDSK : byte;
var d:byte;
Begin
  r.HL.W := $0000;
  d:= r.BC.L;     //in C, 0=a, 1=b etc
  If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('CPM SELDISK '+hexbyte(r.bc.l));
  Result := $00;
  if (d>3) then begin
    //ShowMessage('CPM SELDSK error. Disk ='+Chr(65+d)+':   BC='+HexWord(r.bc.w)+' DE ='+HexWord(r.de.w));
    Form1.Memo3.Lines.add('CPM SELDSK error. Disk ='+Chr(65+d)+': A='+HexByte(r.a)+' BC='+HexWord(r.bc.w)+' DE ='+HexWord(r.de.w));
    result := $01;  r.hl.w := $00;
    exit;
    end;
  if d in [0..3] then begin
{$I-}
      Case CPMDISK of
        0 : Close(CpmDiskAFile);
        1 : Close(CpmDiskBFile);
        2 : Close(CpmDiskCFile);
        3 : Close(CpmDiskDFile);
        end;
      IF IORESULT = 0 then;  //clear error on close
      Case d of
        0 : Begin AssignFile(CpmDiskAFile,Drive4Name); reset(cpmDiskAFile); end;
        1 : Begin AssignFile(CpmDiskBFile,Drive5Name); reset(cpmDiskBFile); end;
        2 : Begin AssignFile(CpmDiskCFile,Drive9Name); reset(cpmDiskCFile); end;
        3 : Begin AssignFile(CpmDiskDFile,Drive10Name);reset(cpmDiskDFile); end;

        end;  //case
      With Form1 do Case d of
        0 : begin SpeedButton2.Down := true; sleep(15); end;
        1 : begin SpeedButton3.Down := true; sleep(15); end;
        2 : begin SpeedButton4.Down := true; sleep(15); end;
        3 : begin SpeedButton5.Down := true; sleep(15); end;
        end;

      If IORESULT = 0 then begin //all ok
        CPMDISK  := d;  //in C, 0=a, 1=b etc
        r.A := 0;  //pass back no error code
        r.HL.W := $0100;
        Result := $00;
        end
      else begin  //error opening virtual disc
        CPMDISK := $22;
        r.A := $01;  //pass back error code
        r.bc.l := $01;
        r.HL.W := $0000;
        result:=$01;
        end;
      end;  //d in 0..3
end;


Function CPMReadSector:byte;
Var Sector : TSector;  var i:integer; io : Integer;
Begin
  If not CPMDISK in [0..3] then begin
    for i:=0 to 127 do Memory[CPMDMA+i] := 00;  //Clear DMA buffer
    Result := 01;  Exit;
    end;
{$I-}
  Case CPMDISK of
    0: Begin Seek(CpmDiskAFile,CPMTRACK*26 + (CPMSECTOR-1)); Read(CpmDiskAfile,Sector); end;
    1: Begin Seek(CpmDiskBFile,CPMTRACK*26 + (CPMSECTOR-1)); Read(CpmDiskBfile,Sector); end;
    2: Begin Seek(CpmDiskCFile,CPMTRACK*26 + (CPMSECTOR-1)); Read(CpmDiskCfile,Sector); end;
    3: Begin Seek(CpmDiskDFile,CPMTRACK*26 + (CPMSECTOR-1)); Read(CpmDiskDfile,Sector); end;
    end;
{$I+}
  If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('CPM ReadSector '+inttoStr(CPMTRACK*26+CPMSECTOR-1));
  io := IORESULT;
  if io = 0 then begin
//    CPMDISK  := d;  //in C, 0=a, 1=b etc
    for i:=0 to 127 do Memory[CPMDMA+i] := Sector[i];
    Result := $00; //no error
    exit;
    end;
  if io>0 then begin
    Form1.Memo3.Lines.Add('CPM ReadSector error. Drive '+CHR(CPMDISK+65)+':   T='+IntToStr(CPMTRACK)+
    ' S='+IntToStr(CPMSECTOR)+' Error = '+IntToStr(io));
    result := $01;
    for i:=0 to 127 do Memory[CPMDMA+i] := 00;  //Clear DMA buffer
    exit;
    end;
end;

Function CPMWriteSector:byte;
Var Sector : TSector;  var i:integer;
    io : Integer;
Begin
  If not CPMDISK in [0..3] then begin
    Result := 01;  Exit;
    end;
  Result := $00;
  for i:=0 to 127 do
    Sector[i]:=Memory[CPMDMA+i];
  DumpSector(Sector);
{$I-}
  Case CPMDISK of
    0: Begin Seek(CpmDiskAFile,CPMTRACK*26 + (CPMSECTOR-1)); Write(CpmDiskAfile,Sector); end;
    1: Begin Seek(CpmDiskBFile,CPMTRACK*26 + (CPMSECTOR-1)); Write(CpmDiskBfile,Sector); end;
    2: Begin Seek(CpmDiskCFile,CPMTRACK*26 + (CPMSECTOR-1)); Write(CpmDiskCfile,Sector); end;
    3: Begin Seek(CpmDiskDFile,CPMTRACK*26 + (CPMSECTOR-1)); Write(CpmDiskDfile,Sector); end;
    end;
{$I+}
  io := IORESULT;
  If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('CPM WriteSector '+inttoStr(CPMTRACK*26+CPMSECTOR-1));
  if io>0 then begin
    showmessage('CPM WriteSector error of T='+IntToStr(CPMTRACK)+
    ' S='+IntToStr(CPMSECTOR)+' Error = '+IntToStr(io));
    r.a := $01;  //error
    Result := $01;
    exit;
    end;
//  Move(Sector,aZ80Mem^[CPMDMA],Sizeof(Sector));
  r.A := 0;  //pass back no error code
  REsult := 00;
end;

Function HandleBIOSCall(adr:word):byte;
var fn:integer; IOR:byte; //result of function
Begin
  Application.ProcessMessages;
  //function x 3 in L register
  fn := r.HL.L;  //fn := r.HL.W and $00FF;
  fn := (fn div 3)-1;  //L div 3 is CPM functon+1 as div 3 cannot give result of 0
  Case fn of
    0 : CPMWBOOT;
    1 : CPMCONST;  //
    2 : CONIN;  //Wait for char, return it in A
    3 : Case Terminal of //CONOUT;
          TTNone  : Begin  //no terminal
                    Form1.CRT.WriteChar(char(r.BC.l));   //CONOUT WriteChar in C;
                    If Form1.ShowDebugOut.Checked then begin
                      Form1.Memo3.Lines.Add('CPM CONOUT '+char(r.bc.l));
                        if r.BC.l < 32 then
                        Form1.Memo3.Lines.Add('ctrl-char = '+IntToStr(r.bc.l));
                      end;
                    end;

          TTSoroc : CONOUTSoroc;
          TTADM3A : CONOUTADM3A;
          TTVT52  : CONOUTVT52;
          TTVT100 : CONOUTVT100;
          TTTerak : CONOUTTerak;
          end;
    4 : LIST;
    5 : PUNCH;
    6 : READER;
    7 : CPMHOME;   //Home current disk...goto T0
    8 : Begin
        IOR := CPMSELDSK;  //in C, 0=a, 1=b etc
        if IOR > 0 then begin
          r.HL.w := $0000;  //could not select drive
          //for compatability reasons, A=L and B=H on return
//          r.BC.h := r.HL.h;
//          r.HL.l := r.A;
          Result := IOR;
          exit;
          end
        else begin
          r.HL.w := $0101;  //no error
          //for compatability reasons, A=L and B=H on return
          r.BC.h := r.HL.h;
          r.HL.l := r.A;
          Result := IOR;
          exit;
          end;
        end;
    9 : Begin //SETTRK
        CPMTRACK := r.BC.l;    //was .W
        If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('CPM SETTRK $'+hexbyte(r.bc.l));
        end;
    10: Begin //SETSEC
        CPMSECTOR:= r.BC.l;   //Watch it, sector in C
        If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('CPM SETSEC $'+hexbyte(r.bc.l));
        end;
    11: Begin  //SETDMA
        CPMDMA   := r.BC.W;
        If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('CPM SETDMA $'+hexword(r.bc.w));
        end;
    12: IOR := CpmReadSector; //READ
    13: IOR := CpmWriteSector;//WRITE
      ELSE begin
        If Form1.ShowDebugOut.Checked then Form1.Memo3.Lines.Add('UNIMPLEMENTED CP/M BIOS FUNCTION  L='+HexByte(r.HL.l)+
                                      ' SP=$'+HexWord(r.sp.W)+' A=$'+HexWord(r.A)+' Address='+HexWord(adr));
        SHOWMESSAGE('UNIMPLEMENTED CP/M BIOS FUNCTION L='+HexByte(r.HL.l)+' Address='+HexWord(adr)+' SP=$'+HexWord(r.sp.W));
        r.enabled := false;
        end;
    end;  //case
  //Temp patch
  if fn in [8,12,13] then begin r.A := IOR; r.bc.l := IOR; end;
  if fn in [4,9,10,11] then
    r.A := 0;  //pass back no error code
  Result := r.A;
  //for compatability reasons, A=L and B=H on return
  r.BC.h := r.HL.h;
  r.HL.l := r.A;
  if fn = 8 then begin
    if ior>0 then
    Form1.Memo3.Lines.Add('***SELDSK error.  HL = '+HexWord(r.HL.w)+ ' A=$'+HexWord(r.A));
    end;
end;

Procedure Handle0005Call;
var  URTN : Word;  i:integer; c:char;
Begin
//  ShowMessage('CALL $0005 detected, C='+HexByte(lo(BC)));
  i:=0;
  Case r.BC.l of
    0 : Begin  //System Reset
        ShowMessage('System reset BDOS Call ($0005) C=0');
        r.enabled := false;  //stop Z80 machine
        end;
    1 : begin// Wait for char, echo and return Returns A=L=character.
        Repeat Application.ProcessMessages until CRTKeypressed = true;
          r.A := byte(CRTKEY); r.hl.l := r.A;
        end;
    2 : begin c:= Chr(r.DE.l); Form1.CRT.Write(c);
        Form1.TraceMemo.Lines.text := Form1.TraceMemo.Lines.text + c;
        end;
    9 : Begin
        Repeat
        c:= Chr(Memory[r.DE.w+i]); if c<>'$' then begin
          Form1.CRT.Write(c);
          Form1.TraceMemo.Lines.text := Form1.TraceMemo.Lines.text + c;
          end;
        inc(i);
        until c='$';
        end;
    else begin
         showmessage(' Unhandled bdos ($0005) call :'+HexByte(r.BC.l));
         r.enabled := false;  //stop Z80 machine
         end;
    end;
end;







function Machine_GetByte(direccion: Word): Byte; pascal;
var
  RV: Byte;
begin
 // Form1.TraceMemo.Lines.Add(HexWord(r.pc.w)) ;
// SIMPLE TRACE OF pc //  Form1.PCTraceCRT.Writeln(HexWord(nEnder));
//if you want some indication of activity....next line
//  Form1.Label3.Caption := HexWord(direccion);

  If (direccion >=$FF00) and (direccion <=$FFFF) then begin
    r.A := HandleBiosCall(direccion);
    r.BC.l := r.A;   //error code into reg C? LB today
    Machine_GetByte := 201;   // pass back opcode for RET
    //inc(r.pc.w,1);     //not needed
    exit;
    end;


//We only intercept on opcode fetch cycle
  if not r.opcode then begin
    Machine_GetByte := Memory[direccion];
    exit;
    end;
//if here then an opcode fetch

//If at BACK then check for PCodeBPT
(*  Disabled as now does any interp.  LB 3/6/2011
  if Direccion = $039A { 039A BACK FOR Z80TMICR} then if r.bc.w = PCodeBPT then begin
    step:=0;
    Form1.Status.Caption :='At breakpoint $'+HexWord(r.pc.w);
    Show_Stack;
    Show_Registers;
    Form1.AssemblerCRT.ClrScr;
    Form1.AssemblerCRT.gotoxy(3,2);
    U_IP := r.PC.W;
    for dum:=1 to 23 do unassemble_code;
    While Step=0 do Application.ProcessMessages; //wait for button press
    Form1.Status.Caption :='Running';
    end;
*)
//Handle break point
  if CheckForBreakpoint(direccion)>0 then begin
    step:=0;
    Form1.Status.Caption :='Status: At breakpoint $'+HexWord(r.pc.w);
    Show_Stack;
    Show_Registers;
    Form1.AssemblerCRT.ClrScr;
    Form1.AssemblerCRT.gotoxy(3,2);
    U_IP := r.PC.W;
    for dum:=1 to 20 do unassemble_code;
    While Step=0 do Application.ProcessMessages; //wait for button press
    Form1.Status.Caption :='Status: Running';
    end;

//  AtWarmBoot  := direccion=$0000;    //Disabled LB 3/6/2011
  AtIntercept := direccion=$0005;
  Application.ProcessMessages;
  If (direccion >=$FF03) and (direccion <=$FFFF) then begin
    ShowMessage('Intercept at $FF03 to $FFFF');
    r.enabled := false;
    exit;
    end;
(*
  If (direccion >=$FE00) and (direccion <=$FFFF) then begin
    HandleBiosCall;
    Machine_GetByte := 201;   // pass back opcode for RET
    //inc(r.pc.w,1);     //not needed
    exit;
    end;
*)
  (*  only for Z80TMICRO  *)

(* Disabled LB 3/6/2011
  IF direccion = $2283  { $22AB FOR SYSMICROI5 $230d for z80t20mic,  $2283 for Z80tMICR} {BIOS} then begin
    HandleBIOSCall;
    Machine_GetByte := 201;   //pass back opcode for RET
    //inc(r.pc.w,1);     //not needed
    exit;
    end;
*)
  If AtIntercept then begin
    Handle0005Call;
    //and pass back an RET
      Machine_GetByte := 201;   //opcode for RET
      AtIntercept:=false;
      exit;
      end;
  If AtWarmBoot then begin
    ShowMessage('CM/P warm boot intercepted (JMP $0000)');
    r.enabled := false; // reset_z80(r);
    //btnShowStateClick(Sender);
    exit;
    end;

  //intercept here if you want
  if direccion=$FE03 then begin
    ShowMessage('Unexpected arrival at $FE03');//do some code here if you want
    end;

  If SingleStep and r.opcode then begin   //Only pause before opcode fetch
    dec(Step);
    If Step = 0 then begin
      Form1.Status.Caption :='Single stepping at $'+HexWord(r.pc.w);
      Show_Stack;
      Show_Registers;
      Form1.AssemblerCRT.ClrScr;
      Form1.AssemblerCRT.gotoxy(3,2);
      U_IP := r.PC.W;
      for dum:=1 to 20 do unassemble_code;
      While Step=0 do Application.ProcessMessages; //wait for button press
      If SingleStep then
        Form1.Status.Caption :='Single stepping leaving $'+HexWord(r.pc.w);
      end;
    end;

(*
  if direccion=$20B7 then begin  //Change A after GETU
    if r.A > 7 then
      r.A :=7;
    end;
*)
  Machine_GetByte := Memory[direccion];
  If Form1.ShowPC.checked then begin
    Form1.Label8.Caption := dec_to_Hex(r.pc.w,4);
    end;
end;



procedure Machine_putbyte(direccion:word;valor:byte);pascal;
begin
  memory[direccion]:=valor;
end;

function Machine_inbyte(puerto:word):byte;pascal;
begin
end;

procedure Machine_outbyte(valor:byte;puerto:word);pascal;
begin
end;
procedure Machine_despues_instruccion(estados_t:word);pascal;  //was byte LB
//gets called at end of opcode decode loop
begin
  //I think that this is a call back reporting how many cycles the last opcode took
//  showMessage('estados_t is '+intToStr(estados_t));
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
  With ll do begin
    GetByte := Machine_Getbyte;
    putbyte := Machine_PutByte;
    Inbyte  := Machine_InByte;
    Outbyte := Machine_OutByte;
    despues_instruccion := Machine_despues_instruccion;
    end;
  New(r);  //  getmem(r,sizeof(reg_z80));

  Dis1;
   //set up components
  StringGrid1.Cells[0,0]:='Address';
  StringGrid1.Cells[1,0]:='Label';

  //Show CPU registers
  for i:= 3 to 11 do begin
    RegisterCrt.GotoXY(2,i-2);
    RegisterCRT.Write(Zin(i));
    end;
  for i:= 12 to 18 do begin
    RegisterCrt.GotoXY(12,i-11);
    RegisterCRT.Write(Zin(i));
    end;

  Terminal := TTVT52; Label13.Caption :='VT-52'; //RadioGroup3Click(Sender);// Force click to make Terminal := VT52;   //This is the startState;
  DisplayOffset := $0000;    //offset to display memory contents.
  DisplayAsHex  := true; // show as hex or Ascii

  NumLabels := 150;      //number of symbolic labels for a code file
  StringGrid1.RowCount := NumLabels+1;

  CPMDISK := 0;   //start with A: drive
  Drive4Name := 'c:\ucsdI5-1.RAW'; //'c:\iisource\*.*'; //'C:\BOOP.RAW';
  DiskSector := 1;  //1..26
  DiskTrack := 0;   //0..76

  Drive5Name := 'c:\*.raw'; //'c:\iisource\*.*'; //'C:\15FIX1.RAW';

  SingleStep := False;   Step := 0;
  PCodeBPT := 0;
end;

var maximo : Longword;
procedure TForm1.btnRunZ80Click(Sender: TObject);
begin
  maximo:=maxint;   //was r.maximo LB
  CRT.SetFocus;
  r.enabled := true;
  Status.Caption :='Status: Running';
  run_Z80(r,ll,maximo);
  Status.Caption :='Status: CPU Stopped';
  ShowMessage('Z80 emulation has stopped. Back from run_Z80()');

end;


var FileLabelName: String;
procedure TForm1.btnLoadCodeClick(Sender: TObject);
var f:file of byte;
      f1:textfile; x,i,size:integer; StartAddress: Integer;
    a,l : ShortString;
begin
    //Make $0000 look like JMP FE03, and $0005 like JMP FF00
    memory[0]:=$C3;
    memory[1]:=$03;
    memory[2]:=$FF;
    memory[5]:=$C3;
    memory[6]:=$00;
    memory[7]:=$F4;

  OpenDialog1.FileName :='PASCAL.COM'; // 'c:\turbo\assembler\pascal.com'; //'Z80TMICR';  //'U-prof.rom';
  Case LoadCodeAddress.ItemIndex of
    0 : StartAddress := $0100;
    1 : StartAddress := $0000;
    2 : Begin
        StartAddress := Hex_to_Dec(Edit9.Text);
        end;
    end;
  if OpenDialog1.execute then begin
    AssignFile(f,OpenDialog1.FileName);
    Reset(f);
    Size:=filesize(f);
    //CP/M FILES LOAD AT $0100 NOT $0000
    for i:= 0 to size-1 do read(f,memory[i+StartAddress]);
    CloseFile(f);

    btnSetPCClick(Sender);   //set Z80 PC at $0100
{$I-}
    FileLabelName :=OpenDialog1.FileName+'.LAB';
    AssignFile(f1,FileLabelName);
    Reset(f1);
    Readln(f1,x);
    for i:= 1 to x do begin
      Readln(f1,a);
      While length(a) < 4 do a:='0'+a;
      Readln(f1,l);
      StringGrid1.Cells[0,i]:=a; StringGrid1.Cells[1,i]:=l;
      end;
    CloseFile(f1);
    If IORESULT = 0 then;
{$I+}
    end;
end;
procedure TForm1.btnSetPCClick(Sender: TObject);
Var Address:word;  dum:integer;
begin
  Address := Hex_to_Dec(Edit2.text);
  r.PC.W := Address;
  show_registers;
  U_IP:=Address;
  Form1.AssemblerCRT.gotoxy(3,2);
  for dum:=1 to 20 do unassemble_code;       { zet nieuwe NEXT_IP }
  next_IP:=$FFFF;
end;
procedure TForm1.ListBox1Click(Sender: TObject);
begin
  Edit1.text := ListBox1.Items.Strings[ListBox1.ItemIndex];
end;



procedure TForm1.Button2Click(Sender: TObject);
var x:integer;   address:word;
begin
  address := Hex_to_Dec(Edit1.Text);
  x:= CheckforBreakpoint(address);
  if x>0 then begin
    RemoveBreakpoint(x);
    x:= ListBox1.Items.IndexOf(Edit1.text);
    ListBox1.Items.Delete(x);
    end;
end;



procedure TForm1.Button3Click(Sender: TObject);
var address : word;
begin  //add breakpoint
  address := Hex_to_Dec(Edit1.Text);
  if CheckforBreakpoint(address)=0 then begin
    addBreakpoint(address);
    ListBox1.Items.Add(Edit1.text);
    end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  LAbel1.Caption := IntToStr(Hex_to_Dec(Edit1.text));
end;



procedure TForm1.StringGrid1Click(Sender: TObject);
var dum:integer;
begin
  Edit1.Text := UpperCase(StringGrid1.Cells[0,StringGrid1.Row]);
  //Also do a disassemble of that code
  U_IP:=Hex_to_Dec(StringGrid1.Cells[0,StringGrid1.Row]);
  Form1.AssemblerCRT.gotoxy(3,2);
  for dum:=1 to 20 do unassemble_code;       { zet nieuwe NEXT_IP }
  next_IP:=$FFFF;
end;
procedure TForm1.btnDrive4Click(Sender: TObject);
begin
  OpenDialog1.FileName := Drive4Name;
  If OpenDialog1.Execute then begin
    Drive4Name := OpenDialog1.Filename;
    Label2.Caption := ExtractFilename(Drive4Name);
    Label16.Caption := 'in '+ExtractFilePAth(Drive4Name);
//    CPMDISKA :=0;
    end;
  CRT.SetFocus;
end;

procedure TForm1.btnDrive5Click(Sender: TObject);
begin
  OpenDialog1.FileName := Drive5Name;
  If OpenDialog1.Execute then begin
    Drive5Name := OpenDialog1.Filename;
    Label9.Caption := ExtractFilename(Drive5Name);
    Label17.Caption := 'in '+ExtractFilePAth(Drive5Name);
//    CPMDISKA :=0;
    end;
  CRT.SetFocus;
end;

procedure TForm1.btnDrive9Click(Sender: TObject);
begin
  OpenDialog1.FileName := Drive9Name;
  If OpenDialog1.Execute then begin
    Drive9Name := OpenDialog1.Filename;
    Label11.Caption := ExtractFilename(Drive9Name);
    Label18.Caption := 'in '+ExtractFilePAth(Drive9Name);
//    CPMDISKA :=0;
    end;
  CRT.SetFocus;
end;

procedure TForm1.btnDrive10Click(Sender: TObject);
begin
  OpenDialog1.FileName := Drive10Name;
  If OpenDialog1.Execute then begin
    Drive10Name := OpenDialog1.Filename;
    Label12.Caption := ExtractFilename(Drive10Name);
    Label19.Caption := 'in '+ExtractFilePAth(Drive10Name);
//    CPMDISKA :=0;
    end;
  CRT.SetFocus; 
end;


procedure TForm1.btnShowStateClick(Sender: TObject);
begin
  Show_Stack;
  Show_Registers;
  Form1.AssemblerCRT.ClrScr;
  Form1.AssemblerCRT.gotoxy(3,2);
  U_IP := r.PC.W;
  for dum:=1 to 20 do unassemble_code;
end;

procedure TForm1.btnResetZ80Click(Sender: TObject);
//var r:preg_z80;
begin
//  new(r);
  reset_z80(r);
  btnShowStateClick(Sender);
  Status.Caption:='Status: CPU stopped';
end;

procedure TForm1.btnStepClick(Sender: TObject);
begin
  Step := 1;
  If not SingleStep then Status.Caption := 'Running';
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  SingleStep := Not SingleStep;
  if SingleStep then step := 1
                else step := 0;
  With SpeedButton1 do begin
    Down := SingleStep;
    If SingleStep then begin
      Caption := 'Single step enabled';
      Font.Color:=clRed;
      end
    else begin
      Caption := 'enable single step';
      Font.Color := clBlack;
      end;
    end;
end;

procedure TForm1.CRTKeyPress(Sender: TObject; var Key: Char);
begin
  CRTKeypressed := true;
  CRTKEY := Key;
end;

procedure TForm1.btnSaveLabelsClick(Sender: TObject);
var       f1:textfile; x,i,size:integer;
    a,l : ShortString;
begin
{$I-}
    AssignFile(f1,FileLabelName);
    rewrite(f1);
    x:=NumLabels;
    writeln(f1,x);
    for i:= 1 to x do begin
      Writeln(f1,StringGrid1.Cells[0,i]);
      Writeln(f1,StringGrid1.Cells[1,i]);
      end;
    CloseFile(f1);
    If IORESULT = 0 then;
{$I+}
end;

procedure TForm1.btnClearMemoryClick(Sender: TObject);
var i:integer;
begin
  for i:=0 to $FFFF do
    memory[i] := 0;
//  fillchar(Memory[0],Sizeof(Memory),Chr(00));
//  NOW RE-DISPLAY MEMORY
  btnDisplayMemoryClick(Sender);
end;

procedure TForm1.btnDisplayMemoryClick(Sender: TObject);
var i,j:word; s:shortString;   c:char;
begin
  Form1.Memo1.Clear;
  Label6.Caption := 'Start = '+HexWord(DisplayOffset);
  for i:= 0 to 15 do begin
    s:= HexWord(DisplayOffset+(i*16))+':';
    for J := 0 to 15 do begin
      if DisplayAsHex then
        s:=s+' '+Hexbyte(Memory[DisplayOffset+(i*16)+j])
      else begin  //DisplayAsAscii
        c:= char(Memory[DisplayOffset+(i*16)+j]);
        if not (c in [' '..'~']) then c:='.';
        s:=s+' '+' '+c;
        end;
      end;
    Form1.Memo1.Lines.Add(s);
    end;
end;

procedure TForm1.btnMemorydownClick(Sender: TObject);
begin
  Dec(DisplayOffset,$0100);
  btnDisplayMemoryClick(Sender);
end;

procedure TForm1.btnMemoryUpClick(Sender: TObject);
begin
  Inc(DisplayOffset,$0100);
  btnDisplayMemoryClick(Sender);
end;


procedure TForm1.btnMemoryDownDownClick(Sender: TObject);
begin
  Dec(DisplayOffset,$1000);
  btnDisplayMemoryClick(Sender);
end;

procedure TForm1.btnMemoryUpUpClick(Sender: TObject);
begin
  Inc(DisplayOffset,$1000);
  btnDisplayMemoryClick(Sender);
end;





procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  DisplayAsHex := (RadioGroup1.ItemIndex = 0);
  btnDisplayMemoryClick(Sender);
end;



procedure TForm1.btnSubroutineCallClick(Sender: TObject);
var address : Word; x:integer;
begin
  // opcode is $CD at IP
  //Place temp break point at IP + 3, if one not already there
  //do run to bpt
  //remove bpt, if one was not orinally there
  If Memory[r.PC.W] = $CD then begin
    address := r.PC.W + 3;
    x:= CheckforBreakpoint(address);
    if x = 0 then begin  //there is no bpt so add it, do call, remove it
      addBreakpoint(address);
      SingleStep := false;
      btnStepClick(sender);
      x:= CheckforBreakpoint(address);
      if x>0 then RemoveBreakpoint(x);
      SingleStep:= true; Step := 0;
      end
    else begin    //there is already a bpt at the return address, dont change it
      btnStepClick(sender);
      end;
    end;
end;

procedure TForm1.btnPatchitClick(Sender: TObject);
var Address : Word; OldVal, NewVal: Byte;
begin
  Address := Hex_to_Dec(Edit3.Text);
  OldVal  := Hex_to_dec(Edit4.text);
  NewVal  := Hex_To_Dec(Edit5.text);

  If Memory[Address] =OldVal then
    Memory[Address] := NewVal;
end;
procedure TForm1.btnStopZ80CPUClick(Sender: TObject);
begin
 r.enabled := false;
 Status.Caption := 'Status: stopping CPU';
end;

procedure TForm1.CRTClick(Sender: TObject);
begin
  CRT.SetFocus;
end;



procedure TForm1.btnDiskReadClick(Sender: TObject);
var rec,i,j:integer;  s:string; c:char;
    Sector : TSector;
begin
  //read and display at current T/S
  Rec := DiskTrack *26 + DiskSector-1;
  Case CPMDISK of
    0: Begin Seek(CpmDiskAFile,Rec); Read(CpmDiskAfile,Sector); end;
    1: Begin Seek(CpmDiskBFile,Rec); Read(CpmDiskBfile,Sector); end;
    2: Begin Seek(CpmDiskCFile,Rec); Read(CpmDiskCfile,Sector); end;
    3: Begin Seek(CpmDiskDFile,Rec); Read(CpmDiskDfile,Sector); end;
    end;
//  Seek(CPMDiskFile,Rec);   Read(CPMDiskFile,sector);
  Form1.Memo2.Clear;
  s := 'T= '+IntToStr(DiskTrack)+'  S= '+IntToStr(DiskSector);
  Form1.memo2.Lines.Add(s);
  for i:= 0 to 7 do begin
    s:= HexWord(DisplayOffset+(i*16))+':';
    for J := 0 to 15 do begin
      if DiskDisplayAsHex then
        s:=s+' '+Hexbyte(Sector[(i*16)+j])
      else begin  //DisplayAsAscii
        c:= char(sector[(i*16)+j]);
        if not (c in [' '..'~']) then c:='.';
        s:=s+' '+' '+c;
        end;
      end;
    Form1.Memo2.Lines.Add(s);
    end;


end;

procedure TForm1.btnSectorUpClick(Sender: TObject);
begin
  inc(DiskSector);
  if DiskSector = 27 then begin
    DiskSector :=1;
    btnTrackUpClick(sender);
    end
  else
    btnDiskreadClick(sender);
end;

procedure TForm1.btnTrackUpClick(Sender: TObject);
begin
  inc(Disktrack);
  btnDiskreadClick(sender);
end;

procedure TForm1.btnSectorDownClick(Sender: TObject);
begin
  dec(DiskSector);
  if DiskSector = 0 then begin
    DiskSector :=26;
    btnTrackDownClick(sender);
    end
  else
    btnDiskreadClick(sender);
end;

procedure TForm1.btnTrackDownClick(Sender: TObject);
begin
  if DiskTrack > 0 then
    dec(Disktrack);
  btnDiskreadClick(sender);
end;

procedure TForm1.RadioGroup2Click(Sender: TObject);
begin
  DiskDisplayAsHex := (RadioGroup2.ItemIndex = 0);
  btnDiskreadClick(Sender);
end;

procedure TForm1.btnOpenDiskfileClick(Sender: TObject);
begin
  OpenDialog1.FileName := Drive4Name;
  If OpenDialog1.Execute then begin
    Drive4Name := OpenDialog1.Filename;
    AssignFile(CpmDiskAFile,Drive4Name);
    reset(cpmDiskAFile);
    end;
end;






procedure TForm1.Button1Click(Sender: TObject);
var Value : integer;
begin
  Value :=  Hex_to_Dec(Edit6.Text);
  Edit7.Text := INtToStr(Value);
  if Value>32767 then label10.Caption := IntToStr(Value-65536)
                 else Label10.Caption := '';
end;

procedure TForm1.btnSetPcodeBreakPointClick(Sender: TObject);
begin
  //Set Pcode breakpoint by looking at BACK and what BC is
  //BC is the address of the p-code to break at
  Edit8.text := Dec_To_Hex(Hex_To_Dec(Edit8.text),4);
  PCodeBPT := Hex_To_Dec(Edit8.text);
end;

procedure TForm1.RadioGroup3Click(Sender: TObject);
var s:string;
begin
  s:= 'Terminal = ';
  Case RadioGroup3.ItemIndex of
    0 : Begin Terminal := TTNone; s:=s+ 'NONE'; end;
    1 : Begin Terminal := TTSoroc;s:=s+ 'SOROC IQ 120'; end;
    2 : Begin Terminal := TTADM3A;s:=s+ 'ADM-3A'; end;
    3 : Begin Terminal := TTVT52; s:=s+ 'VT-52'; end;
    4 : Begin Terminal := TTVT100;s:=s+ 'VT-100'; end;
    5 : Begin Terminal := TTTERAK;s:=s+ 'Terak'; end;
    end;
  Label13.Caption := s;
  CRT.SetFocus;
end;


procedure TForm1.CRTKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//  ShowMessage('OnKeyUp = '+IntToStr(Key));
//  Only map arrow keys to control chars
  if Key in [37..40] then begin
    CRTKeypressed := true;
    Case key of    //These for AMD-3A terminal
      37 : CRTKey := chr(08); //left arrow
      38 : CRTKey := chr(11); //up arrow
      39 : CRTKey := chr(12); //right arrow
      40 : CRTKey := chr(10); //down arrow
      end; //case
    end;
end;

procedure TForm1.CopyCRTtoclip1Click(Sender: TObject);
begin
  CRT.Copy;  //Copy CRT screen to clip
end;

procedure TForm1.CRTMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
    PopupMenu1.Popup(X+CRT.Left+Form1.Left,Y+CRT.Top+Form1.Top);
end;

procedure TForm1.LoadCodeAddressClick(Sender: TObject);
begin
  Edit9.SetFocus;
end;

procedure TForm1.DeftEdit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Var Value:integer;
begin
  if Key = 13 then begin
    Value := MyStrToInt(DeftEdit1.Text);
    //regular row value is 24, SYSTEM.EDITOR stuffs up on other values
    if Value in [18..34] then CRT.Rows := Value;
    Label15.Caption := 'Lines = '+IntToStr(CRT.Rows);
    CRT.SetFocus;
    end;
end;

procedure TForm1.Loadcode1Click(Sender: TObject);
begin
  btnLoadCodeClick(Sender);
end;

procedure TForm1.N41Click(Sender: TObject);
begin
  btnDrive4Click(Sender);
end;

procedure TForm1.N51Click(Sender: TObject);
begin
  btnDrive5Click(Sender);
end;

procedure TForm1.N91Click(Sender: TObject);
begin
  btnDrive9Click(Sender);
end;

procedure TForm1.N101Click(Sender: TObject);
begin
  btnDrive10Click(Sender);
end;

procedure TForm1.StartZ80emulatoratPC1Click(Sender: TObject);
begin
   btnRunZ80Click(Sender);
end;

procedure TForm1.sTopZ80emulator1Click(Sender: TObject);
begin
  btnStopZ80CPUClick(Sender);
end;

procedure TForm1.ResetZ801Click(Sender: TObject);
begin
  btnResetZ80Click(Sender);
end;

procedure TForm1.Quit1Click(Sender: TObject);
begin
  r.enabled := false;
  Close;
  Application.Terminate;
  //Just incase we were at a breakpoint and did not terminate...
  Step := 1;
  Close;
end;

procedure TForm1.btnShowState2Click(Sender: TObject);
begin
  btnShowStateClick(Sender);
end;

procedure TForm1.Help1Click(Sender: TObject);
begin
  EMHelp.ShowModal;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  EMAboutBox.ShowModal;
end;

end.

(*
+ Lear Seigler ADM-3A -----------------------------------------------
The ADM-3A video terminal was a popular "glass teletype" of the era,
and was implemented with a large board full of TTL logic (no micro!)
The following control codes are supported in the simulator:

^G          Sound alarm (beep)           Televideo Extensions
^H          Backspace cursor        ------------------------------
^J          Line feed               ^[ T    Clear to end of line
^K          Move cursor up          ^[ Y    Clear to end of screen
^L          Move cursor forward     ^[ E    Insert line
^M          Carriage return         ^[ R    Delete line
^Z          Clear screen            ^[ Q    Insert character
^^          Home cursor             ^[ W    Delete character
^[ = x y    Position cursor (X & Y offset by 20)

*)
